/*
 * Note: this file originally auto-generated by mib2c
 * using mfd-interface.m2c
 */
/*
 * *********************************************************************
 * *********************************************************************
 * *********************************************************************
 * ***                                                               ***
 * ***  NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE  ***
 * ***                                                               ***
 * ***                                                               ***
 * ***       THIS FILE DOES NOT CONTAIN ANY USER EDITABLE CODE.      ***
 * ***                                                               ***
 * ***                                                               ***
 * ***       THE GENERATED CODE IS INTERNAL IMPLEMENTATION, AND      ***
 * ***                                                               ***
 * ***                                                               ***
 * ***    IS SUBJECT TO CHANGE WITHOUT WARNING IN FUTURE RELEASES.   ***
 * ***                                                               ***
 * ***                                                               ***
 * *********************************************************************
 * *********************************************************************
 * *********************************************************************
 */

/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-features.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "applTable.h"


#include <net-snmp/agent/table_container.h>
#include <net-snmp/library/container.h>

#include "applTable_interface.h"

netsnmp_feature_require(baby_steps);
netsnmp_feature_require(row_merge);
netsnmp_feature_require(check_all_requests_error);

#include <ctype.h>

/**********************************************************************
 **********************************************************************
 ***
 *** Table applTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * NETWORK-SERVICES-MIB::applTable is subid 1 of application.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.27.1, length: 8
 */
typedef struct applTable_interface_ctx_s {

    netsnmp_container *container;

    applTable_registration *user_ctx;

    netsnmp_table_registration_info tbl_info;

    netsnmp_baby_steps_access_methods access_multiplexer;

} applTable_interface_ctx;

static applTable_interface_ctx applTable_if_ctx;

static void     _applTable_container_init(applTable_interface_ctx *
                                          if_ctx);
static void     _applTable_container_shutdown(applTable_interface_ctx *
                                              if_ctx);


netsnmp_container *
applTable_container_get(void)
{
    return applTable_if_ctx.container;
}

applTable_registration *
applTable_registration_get(void)
{
    return applTable_if_ctx.user_ctx;
}

applTable_registration *
applTable_registration_set(applTable_registration * newreg)
{
    applTable_registration *old = applTable_if_ctx.user_ctx;
    applTable_if_ctx.user_ctx = newreg;
    return old;
}

int
applTable_container_size(void)
{
    return CONTAINER_SIZE(applTable_if_ctx.container);
}

/*
 * mfd multiplexer modes
 */
static Netsnmp_Node_Handler _mfd_applTable_pre_request;
static Netsnmp_Node_Handler _mfd_applTable_post_request;
static Netsnmp_Node_Handler _mfd_applTable_object_lookup;
static Netsnmp_Node_Handler _mfd_applTable_get_values;
/**
 * @internal
 * Initialize the table applTable 
 *    (Define its contents and how it's structured)
 */
void
_applTable_initialize_interface(applTable_registration * reg_ptr,
                                u_long flags)
{
    netsnmp_baby_steps_access_methods *access_multiplexer =
        &applTable_if_ctx.access_multiplexer;
    netsnmp_table_registration_info *tbl_info = &applTable_if_ctx.tbl_info;
    netsnmp_handler_registration *reginfo;
    netsnmp_mib_handler *handler;
    int             mfd_modes = 0;

    DEBUGMSGTL(("internal:applTable:_applTable_initialize_interface",
                "called\n"));


    /*************************************************
     *
     * save interface context for applTable
     */
    /*
     * Setting up the table's definition
     */
    netsnmp_table_helper_add_indexes(tbl_info, ASN_INTEGER,
                                               /** index: applIndex */
                                     0);

    /*
     * Define the minimum and maximum accessible columns.  This
     * optimizes retrieval. 
     */
    tbl_info->min_column = APPLTABLE_MIN_COL;
    tbl_info->max_column = APPLTABLE_MAX_COL;

    /*
     * save users context
     */
    applTable_if_ctx.user_ctx = reg_ptr;

    /*
     * call data access initialization code
     */
    applTable_init_data(reg_ptr);

    /*
     * set up the container
     */
    _applTable_container_init(&applTable_if_ctx);
    if (NULL == applTable_if_ctx.container) {
        snmp_log(LOG_ERR,
                 "could not initialize container for applTable\n");
        return;
    }

    /*
     * access_multiplexer: REQUIRED wrapper for get request handling
     */
    access_multiplexer->object_lookup = _mfd_applTable_object_lookup;
    access_multiplexer->get_values = _mfd_applTable_get_values;

    /*
     * no wrappers yet
     */
    access_multiplexer->pre_request = _mfd_applTable_pre_request;
    access_multiplexer->post_request = _mfd_applTable_post_request;

#ifndef NETSNMP_DISABLE_SET_SUPPORT
#endif

    /*************************************************
     *
     * Create a registration, save our reg data, register table.
     */
    DEBUGMSGTL(("applTable:init_applTable",
                "Registering applTable as a mibs-for-dummies table.\n"));
    handler =
        netsnmp_baby_steps_access_multiplexer_get(access_multiplexer);
    reginfo =
        netsnmp_handler_registration_create("applTable", handler,
                                            applTable_oid,
                                            applTable_oid_size,
                                            HANDLER_CAN_BABY_STEP |
#if (defined(NETSNMP_NO_WRITE_SUPPORT) || defined(NETSNMP_DISABLE_SET_SUPPORT))
                                            HANDLER_CAN_RONLY
#else
                                            HANDLER_CAN_RONLY
#endif                          /* NETSNMP_NO_WRITE_SUPPORT || NETSNMP_DISABLE_SET_SUPPORT */
        );
    if (NULL == reginfo) {
        snmp_log(LOG_ERR, "error registering table applTable\n");
        return;
    }
    reginfo->my_reg_void = &applTable_if_ctx;

    /*************************************************
     *
     * set up baby steps handler, create it and inject it
     */
    if (access_multiplexer->object_lookup)
        mfd_modes |= BABY_STEP_OBJECT_LOOKUP;
    if (access_multiplexer->pre_request)
        mfd_modes |= BABY_STEP_PRE_REQUEST;
    if (access_multiplexer->post_request)
        mfd_modes |= BABY_STEP_POST_REQUEST;

#if !(defined(NETSNMP_NO_WRITE_SUPPORT) || defined(NETSNMP_DISABLE_SET_SUPPORT))
    if (access_multiplexer->set_values)
        mfd_modes |= BABY_STEP_SET_VALUES;
    if (access_multiplexer->irreversible_commit)
        mfd_modes |= BABY_STEP_IRREVERSIBLE_COMMIT;
    if (access_multiplexer->object_syntax_checks)
        mfd_modes |= BABY_STEP_CHECK_OBJECT;

    if (access_multiplexer->undo_setup)
        mfd_modes |= BABY_STEP_UNDO_SETUP;
    if (access_multiplexer->undo_cleanup)
        mfd_modes |= BABY_STEP_UNDO_CLEANUP;
    if (access_multiplexer->undo_sets)
        mfd_modes |= BABY_STEP_UNDO_SETS;

    if (access_multiplexer->row_creation)
        mfd_modes |= BABY_STEP_ROW_CREATE;
    if (access_multiplexer->consistency_checks)
        mfd_modes |= BABY_STEP_CHECK_CONSISTENCY;
    if (access_multiplexer->commit)
        mfd_modes |= BABY_STEP_COMMIT;
    if (access_multiplexer->undo_commit)
        mfd_modes |= BABY_STEP_UNDO_COMMIT;
#endif                          /* NETSNMP_NO_WRITE_SUPPORT || NETSNMP_DISABLE_SET_SUPPORT */

    handler = netsnmp_baby_steps_handler_get(mfd_modes);
    netsnmp_inject_handler(reginfo, handler);

    /*************************************************
     *
     * inject row_merge helper with prefix rootoid_len + 2 (entry.col)
     */
    handler = netsnmp_get_row_merge_handler(reginfo->rootoid_len + 2);
    netsnmp_inject_handler(reginfo, handler);

    /*************************************************
     *
     * inject container_table helper
     */
    handler =
        netsnmp_container_table_handler_get(tbl_info,
                                            applTable_if_ctx.container,
                                            TABLE_CONTAINER_KEY_NETSNMP_INDEX);
    netsnmp_inject_handler(reginfo, handler);

    /*
     * register table
     */
    netsnmp_register_table(reginfo, tbl_info);

}                               /* _applTable_initialize_interface */

/**
 * @internal
 * Shutdown the table applTable
 */
void
_applTable_shutdown_interface(applTable_registration * reg_ptr)
{
    /*
     * shutdown the container
     */
    _applTable_container_shutdown(&applTable_if_ctx);
}

void
applTable_valid_columns_set(netsnmp_column_info *vc)
{
    applTable_if_ctx.tbl_info.valid_columns = vc;
}                               /* applTable_valid_columns_set */

/**
 * @internal
 * convert the index component stored in the context to an oid
 */
int
applTable_index_to_oid(netsnmp_index * oid_idx,
                       applTable_mib_index * mib_idx)
{
    int             err = SNMP_ERR_NOERROR;

    /*
     * temp storage for parsing indexes
     */
    /*
     * applIndex(1)/INTEGER/ASN_INTEGER/long(long)//l/a/w/e/R/d/h
     */
    netsnmp_variable_list var_applIndex;

    /*
     * set up varbinds
     */
    memset(&var_applIndex, 0x00, sizeof(var_applIndex));
    var_applIndex.type = ASN_INTEGER;

    /*
     * chain temp index varbinds together
     */
    var_applIndex.next_variable = NULL;


    DEBUGMSGTL(("verbose:applTable:applTable_index_to_oid", "called\n"));

    /*
     * applIndex(1)/INTEGER/ASN_INTEGER/long(long)//l/a/w/e/R/d/h 
     */
    snmp_set_var_value(&var_applIndex, &mib_idx->applIndex,
                       sizeof(mib_idx->applIndex));


    err = build_oid_noalloc(oid_idx->oids, oid_idx->len, &oid_idx->len,
                            NULL, 0, &var_applIndex);
    if (err)
        snmp_log(LOG_ERR, "error %d converting index to oid\n", err);

    /*
     * parsing may have allocated memory. free it.
     */
    snmp_reset_var_buffers(&var_applIndex);

    return err;
}                               /* applTable_index_to_oid */

/**
 * extract applTable indexes from a netsnmp_index
 *
 * @retval SNMP_ERR_NOERROR  : no error
 * @retval SNMP_ERR_GENERR   : error
 */
int
applTable_index_from_oid(netsnmp_index * oid_idx,
                         applTable_mib_index * mib_idx)
{
    int             err = SNMP_ERR_NOERROR;

    /*
     * temp storage for parsing indexes
     */
    /*
     * applIndex(1)/INTEGER/ASN_INTEGER/long(long)//l/a/w/e/R/d/h
     */
    netsnmp_variable_list var_applIndex;

    /*
     * set up varbinds
     */
    memset(&var_applIndex, 0x00, sizeof(var_applIndex));
    var_applIndex.type = ASN_INTEGER;

    /*
     * chain temp index varbinds together
     */
    var_applIndex.next_variable = NULL;


    DEBUGMSGTL(("verbose:applTable:applTable_index_from_oid", "called\n"));

    /*
     * parse the oid into the individual index components
     */
    err = parse_oid_indexes(oid_idx->oids, oid_idx->len, &var_applIndex);
    if (err == SNMP_ERR_NOERROR) {
        /*
         * copy out values
         */
        mib_idx->applIndex = *((long *) var_applIndex.val.string);


    }

    /*
     * parsing may have allocated memory. free it.
     */
    snmp_reset_var_buffers(&var_applIndex);

    return err;
}                               /* applTable_index_from_oid */


/*
 *********************************************************************
 * @internal
 * allocate resources for a applTable_rowreq_ctx
 */
applTable_rowreq_ctx *
applTable_allocate_rowreq_ctx(void *user_init_ctx)
{
    applTable_rowreq_ctx *rowreq_ctx =
        SNMP_MALLOC_TYPEDEF(applTable_rowreq_ctx);

    DEBUGMSGTL(("internal:applTable:applTable_allocate_rowreq_ctx",
                "called\n"));

    if (NULL == rowreq_ctx) {
        snmp_log(LOG_ERR, "Couldn't allocate memory for a "
                 "applTable_rowreq_ctx.\n");
        return NULL;
    }

    rowreq_ctx->oid_idx.oids = rowreq_ctx->oid_tmp;

    rowreq_ctx->applTable_data_list = NULL;

    /*
     * if we allocated data, call init routine
     */
    if (!(rowreq_ctx->rowreq_flags & MFD_ROW_DATA_FROM_USER)) {
        if (SNMPERR_SUCCESS !=
            applTable_rowreq_ctx_init(rowreq_ctx, user_init_ctx)) {
            applTable_release_rowreq_ctx(rowreq_ctx);
            rowreq_ctx = NULL;
        }
    }

    return rowreq_ctx;
}                               /* applTable_allocate_rowreq_ctx */

/*
 * @internal
 * release resources for a applTable_rowreq_ctx
 */
void
applTable_release_rowreq_ctx(applTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("internal:applTable:applTable_release_rowreq_ctx",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    applTable_rowreq_ctx_cleanup(rowreq_ctx);

    /*
     * free index oid pointer
     */
    if (rowreq_ctx->oid_idx.oids != rowreq_ctx->oid_tmp)
        free(rowreq_ctx->oid_idx.oids);

    SNMP_FREE(rowreq_ctx);
}                               /* applTable_release_rowreq_ctx */

/**
 * @internal
 * wrapper
 */
static int
_mfd_applTable_pre_request(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *agtreq_info,
                           netsnmp_request_info *requests)
{
    int             rc;

    DEBUGMSGTL(("internal:applTable:_mfd_applTable_pre_request",
                "called\n"));

    if (1 != netsnmp_row_merge_status_first(reginfo, agtreq_info)) {
        DEBUGMSGTL(("internal:applTable",
                    "skipping additional pre_request\n"));
        return SNMP_ERR_NOERROR;
    }

    rc = applTable_pre_request(applTable_if_ctx.user_ctx);
    if (MFD_SUCCESS != rc) {
        /*
         * nothing we can do about it but log it
         */
        DEBUGMSGTL(("applTable", "error %d from "
                    "applTable_pre_request\n", rc));
        netsnmp_request_set_error_all(requests, SNMP_VALIDATE_ERR(rc));
    }

    return SNMP_ERR_NOERROR;
}                               /* _mfd_applTable_pre_request */

/**
 * @internal
 * wrapper
 */
static int
_mfd_applTable_post_request(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *agtreq_info,
                            netsnmp_request_info *requests)
{
    applTable_rowreq_ctx *rowreq_ctx = (applTable_rowreq_ctx *)
        netsnmp_container_table_row_extract(requests);
    int             rc, packet_rc;

    DEBUGMSGTL(("internal:applTable:_mfd_applTable_post_request",
                "called\n"));

    /*
     * release row context, if deleted
     */
    if (rowreq_ctx && (rowreq_ctx->rowreq_flags & MFD_ROW_DELETED))
        applTable_release_rowreq_ctx(rowreq_ctx);

    /*
     * wait for last call before calling user
     */
    if (1 != netsnmp_row_merge_status_last(reginfo, agtreq_info)) {
        DEBUGMSGTL(("internal:applTable",
                    "waiting for last post_request\n"));
        return SNMP_ERR_NOERROR;
    }

    packet_rc = netsnmp_check_all_requests_error(agtreq_info->asp, 0);
    rc = applTable_post_request(applTable_if_ctx.user_ctx, packet_rc);
    if (MFD_SUCCESS != rc) {
        /*
         * nothing we can do about it but log it
         */
        DEBUGMSGTL(("applTable", "error %d from "
                    "applTable_post_request\n", rc));
    }

    return SNMP_ERR_NOERROR;
}                               /* _mfd_applTable_post_request */

/**
 * @internal
 * wrapper
 */
static int
_mfd_applTable_object_lookup(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *agtreq_info,
                             netsnmp_request_info *requests)
{
    int             rc = SNMP_ERR_NOERROR;
    applTable_rowreq_ctx *rowreq_ctx = (applTable_rowreq_ctx *)
        netsnmp_container_table_row_extract(requests);

    DEBUGMSGTL(("internal:applTable:_mfd_applTable_object_lookup",
                "called\n"));

    /*
     * get our context from mfd
     * applTable_interface_ctx *if_ctx =
     *             (applTable_interface_ctx *)reginfo->my_reg_void;
     */

    if (NULL == rowreq_ctx) {
        rc = SNMP_ERR_NOCREATION;
    }

    if (MFD_SUCCESS != rc)
        netsnmp_request_set_error_all(requests, rc);
    else
        applTable_row_prep(rowreq_ctx);

    return SNMP_VALIDATE_ERR(rc);
}                               /* _mfd_applTable_object_lookup */

/***********************************************************************
 *
 * GET processing
 *
 ***********************************************************************/
/*
 * @internal
 * Retrieve the value for a particular column
 */
NETSNMP_STATIC_INLINE int
_applTable_get_column(applTable_rowreq_ctx * rowreq_ctx,
                      netsnmp_variable_list * var, int column)
{
    int             rc = SNMPERR_SUCCESS;

    DEBUGMSGTL(("internal:applTable:_mfd_applTable_get_column",
                "called for %d\n", column));


    netsnmp_assert(NULL != rowreq_ctx);

    switch (column) {

        /*
         * applName(2)/SnmpAdminString/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H 
         */
    case COLUMN_APPLNAME:
        var->type = ASN_OCTET_STR;
        rc = applName_get(rowreq_ctx, (char **) &var->val.string,
                          &var->val_len);
        break;

        /*
         * applDirectoryName(3)/DistinguishedName/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H 
         */
    case COLUMN_APPLDIRECTORYNAME:
        var->type = ASN_OCTET_STR;
        rc = applDirectoryName_get(rowreq_ctx, (char **) &var->val.string,
                                   &var->val_len);
        break;

        /*
         * applVersion(4)/SnmpAdminString/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H 
         */
    case COLUMN_APPLVERSION:
        var->type = ASN_OCTET_STR;
        rc = applVersion_get(rowreq_ctx, (char **) &var->val.string,
                             &var->val_len);
        break;

        /*
         * applUptime(5)/TimeStamp/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLUPTIME:
        var->val_len = sizeof(u_long);
        var->type = ASN_TIMETICKS;
        rc = applUptime_get(rowreq_ctx, (u_long *) var->val.string);
        break;

        /*
         * applOperStatus(6)/INTEGER/ASN_INTEGER/long(u_long)//l/A/w/E/r/d/h 
         */
    case COLUMN_APPLOPERSTATUS:
        var->val_len = sizeof(u_long);
        var->type = ASN_INTEGER;
        rc = applOperStatus_get(rowreq_ctx, (u_long *) var->val.string);
        break;

        /*
         * applLastChange(7)/TimeStamp/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLLASTCHANGE:
        var->val_len = sizeof(u_long);
        var->type = ASN_TIMETICKS;
        rc = applLastChange_get(rowreq_ctx, (u_long *) var->val.string);
        break;

        /*
         * applInboundAssociations(8)/GAUGE/ASN_GAUGE/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLINBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_GAUGE;
        rc = applInboundAssociations_get(rowreq_ctx,
                                         (u_long *) var->val.string);
        break;

        /*
         * applOutboundAssociations(9)/GAUGE/ASN_GAUGE/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLOUTBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_GAUGE;
        rc = applOutboundAssociations_get(rowreq_ctx,
                                          (u_long *) var->val.string);
        break;

        /*
         * applAccumulatedInboundAssociations(10)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLACCUMULATEDINBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_COUNTER;
        rc = applAccumulatedInboundAssociations_get(rowreq_ctx,
                                                    (u_long *) var->val.
                                                    string);
        break;

        /*
         * applAccumulatedOutboundAssociations(11)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLACCUMULATEDOUTBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_COUNTER;
        rc = applAccumulatedOutboundAssociations_get(rowreq_ctx,
                                                     (u_long *) var->val.
                                                     string);
        break;

        /*
         * applLastInboundActivity(12)/TimeStamp/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLLASTINBOUNDACTIVITY:
        var->val_len = sizeof(u_long);
        var->type = ASN_TIMETICKS;
        rc = applLastInboundActivity_get(rowreq_ctx,
                                         (u_long *) var->val.string);
        break;

        /*
         * applLastOutboundActivity(13)/TimeStamp/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLLASTOUTBOUNDACTIVITY:
        var->val_len = sizeof(u_long);
        var->type = ASN_TIMETICKS;
        rc = applLastOutboundActivity_get(rowreq_ctx,
                                          (u_long *) var->val.string);
        break;

        /*
         * applRejectedInboundAssociations(14)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLREJECTEDINBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_COUNTER;
        rc = applRejectedInboundAssociations_get(rowreq_ctx,
                                                 (u_long *) var->val.
                                                 string);
        break;

        /*
         * applFailedOutboundAssociations(15)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h 
         */
    case COLUMN_APPLFAILEDOUTBOUNDASSOCIATIONS:
        var->val_len = sizeof(u_long);
        var->type = ASN_COUNTER;
        rc = applFailedOutboundAssociations_get(rowreq_ctx,
                                                (u_long *) var->val.
                                                string);
        break;

        /*
         * applDescription(16)/SnmpAdminString/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H 
         */
    case COLUMN_APPLDESCRIPTION:
        var->type = ASN_OCTET_STR;
        rc = applDescription_get(rowreq_ctx, (char **) &var->val.string,
                                 &var->val_len);
        break;

        /*
         * applURL(17)/URLString/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H 
         */
    case COLUMN_APPLURL:
        var->type = ASN_OCTET_STR;
        rc = applURL_get(rowreq_ctx, (char **) &var->val.string,
                         &var->val_len);
        break;

    default:
        if (APPLTABLE_MIN_COL <= column && column <= APPLTABLE_MAX_COL) {
            DEBUGMSGTL(("internal:applTable:_mfd_applTable_get_column",
                        "assume column %d is reserved\n", column));
            rc = MFD_SKIP;
        } else {
            snmp_log(LOG_ERR,
                     "unknown column %d in _applTable_get_column\n",
                     column);
        }
        break;
    }

    return rc;
}                               /* _applTable_get_column */

int
_mfd_applTable_get_values(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *agtreq_info,
                          netsnmp_request_info *requests)
{
    applTable_rowreq_ctx *rowreq_ctx = (applTable_rowreq_ctx *)
        netsnmp_container_table_row_extract(requests);
    netsnmp_table_request_info *tri;
    u_char         *old_string;
    void            (*dataFreeHook)(void *);
    int             rc;

    DEBUGMSGTL(("internal:applTable:_mfd_applTable_get_values",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    for (; requests; requests = requests->next) {
        /*
         * save old pointer, so we can free it if replaced
         */
        old_string = requests->requestvb->val.string;
        dataFreeHook = requests->requestvb->dataFreeHook;
        if (NULL == requests->requestvb->val.string) {
            requests->requestvb->val.string = requests->requestvb->buf;
            requests->requestvb->val_len =
                sizeof(requests->requestvb->buf);
        } else if (requests->requestvb->buf ==
                   requests->requestvb->val.string) {
            if (requests->requestvb->val_len !=
                sizeof(requests->requestvb->buf))
                requests->requestvb->val_len =
                    sizeof(requests->requestvb->buf);
        }

        /*
         * get column data
         */
        tri = netsnmp_extract_table_info(requests);
        if (NULL == tri)
            continue;

        rc = _applTable_get_column(rowreq_ctx, requests->requestvb,
                                   tri->colnum);
        if (rc) {
            if (MFD_SKIP == rc) {
                requests->requestvb->type = SNMP_NOSUCHINSTANCE;
                rc = SNMP_ERR_NOERROR;
            }
        } else if (NULL == requests->requestvb->val.string) {
            snmp_log(LOG_ERR, "NULL varbind data pointer!\n");
            rc = SNMP_ERR_GENERR;
        }
        if (rc)
            netsnmp_request_set_error(requests, SNMP_VALIDATE_ERR(rc));

        /*
         * if the buffer wasn't used previously for the old data (i.e. it
         * was allcoated memory)  and the get routine replaced the pointer,
         * we need to free the previous pointer.
         */
        if (old_string && (old_string != requests->requestvb->buf) &&
            (requests->requestvb->val.string != old_string)) {
            if (dataFreeHook)
                (*dataFreeHook) (old_string);
            else
                free(old_string);
        }
    }                           /* for results */

    return SNMP_ERR_NOERROR;
}                               /* _mfd_applTable_get_values */

/***********************************************************************
 *
 * SET processing
 *
 ***********************************************************************/

/*
 * SET PROCESSING NOT APPLICABLE (per MIB or user setting)
 */
/***********************************************************************
 *
 * DATA ACCESS
 *
 ***********************************************************************/
/**
 * @internal
 */
static void
_container_item_free(applTable_rowreq_ctx * rowreq_ctx, void *context)
{
    DEBUGMSGTL(("internal:applTable:_container_item_free", "called\n"));

    if (NULL == rowreq_ctx)
        return;

    applTable_release_rowreq_ctx(rowreq_ctx);
}                               /* _container_item_free */

/**
 * @internal
 */
static void
_container_free(netsnmp_container * container)
{
    DEBUGMSGTL(("internal:applTable:_container_free", "called\n"));

    if (NULL == container) {
        snmp_log(LOG_ERR,
                 "invalid container in applTable_container_free\n");
        return;
    }

    /*
     * call user code
     */
    applTable_container_free(container);

    /*
     * free all items. inefficient, but easy.
     */
    CONTAINER_CLEAR(container,
                    (netsnmp_container_obj_func *) _container_item_free,
                    NULL);
}                               /* _container_free */

/**
 * @internal
 * initialize the container with functions or wrappers
 */
void
_applTable_container_init(applTable_interface_ctx * if_ctx)
{
    DEBUGMSGTL(("internal:applTable:_applTable_container_init",
                "called\n"));

    /*
     * container init
     */
    applTable_container_init(&if_ctx->container);
    if (NULL == if_ctx->container) {
        if_ctx->container =
            netsnmp_container_find("applTable:table_container");
        if (NULL != if_ctx->container) {
            /*
             * When reporting container management errors, we log the container's
             * name, so set it here.
             */
            if_ctx->container->container_name = strdup("applTable");
        }
    }
    if (NULL == if_ctx->container) {
        snmp_log(LOG_ERR, "error creating container in "
                 "applTable_container_init\n");
        return;
    }

}                               /* _applTable_container_init */

/**
 * @internal
 * shutdown the container with functions or wrappers
 */
void
_applTable_container_shutdown(applTable_interface_ctx * if_ctx)
{
    DEBUGMSGTL(("internal:applTable:_applTable_container_shutdown",
                "called\n"));

    applTable_container_shutdown(if_ctx->container);

    _container_free(if_ctx->container);

}                               /* _applTable_container_shutdown */


applTable_rowreq_ctx *
applTable_row_find_by_mib_index(applTable_mib_index * mib_idx)
{
    applTable_rowreq_ctx *rowreq_ctx;
    oid             oid_tmp[MAX_OID_LEN];
    netsnmp_index   oid_idx;
    int             rc;

    /*
     * set up storage for OID
     */
    oid_idx.oids = oid_tmp;
    oid_idx.len = sizeof(oid_tmp) / sizeof(oid);

    /*
     * convert
     */
    rc = applTable_index_to_oid(&oid_idx, mib_idx);
    if (MFD_SUCCESS != rc)
        return NULL;

    rowreq_ctx =
        (applTable_rowreq_ctx *) CONTAINER_FIND(applTable_if_ctx.container,
                                                &oid_idx);

    return rowreq_ctx;
}
